library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

package common is

	constant YES:	std_logic := '1';
	constant NO:	std_logic := '0';
	constant HI:	std_logic := '1';
	constant LO:	std_logic := '0';
	function log2(v: in natural) return natural;
	function min(a,b: in natural) return natural;
	function max(a,b: in natural) return natural;
	
end package common;


		
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;


package body common is

function log2(v: in natural) return natural is
	variable n: natural;
	variable logn: natural;
begin
	n := 1;
	for i in 0 to 128 loop
		logn := i;
		exit when (n>=v);
		n := n * 2;
	end loop;
	return logn;
end function log2;

function min(a,b: in natural) return natural is
	variable m: natural;
begin
	if(a<b) then
		m := a;
	else
		m := b;
	end if;
	return m;
end function min;	

function max(a,b: in natural) return natural is
	variable m: natural;
begin
	if(a<b) then
		m := b;
	else
		m := a;
	end if;
	return m;
end function max;	

end package body common;



library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

package xilinx is

component IBUFG
	port(
		O:	out	std_ulogic;
		I:	in	std_ulogic
	);
end component;

component CLKDLL
	port(
		CLKIN:	in  std_ulogic := '0';
		CLKFB:	in  std_ulogic := '0';
		RST:		in  std_ulogic := '0';
		CLK0:		out std_ulogic := '0';
		CLK90:	out std_ulogic := '0';
		CLK180:	out std_ulogic := '0';
		CLK270:	out std_ulogic := '0';
		CLK2X:	out std_ulogic := '0';
		CLKDV:	out std_ulogic := '0';
		LOCKED:	out std_ulogic := '0'
	);
end component;

component BUFG
	port(
  	O:	out	std_ulogic;
		I:	in	std_ulogic
	);
end component;

component OBUF
	port(
		O:	out	std_ulogic;
		I:	in	std_ulogic
	);
end component;

end package xilinx;
